package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class CaseCashPlanExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CaseCashPlanExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andCaseCashPlanIdIsNull() {
            addCriterion("case_cash_plan_id is null");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdIsNotNull() {
            addCriterion("case_cash_plan_id is not null");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdEqualTo(String value) {
            addCriterion("case_cash_plan_id =", value, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdNotEqualTo(String value) {
            addCriterion("case_cash_plan_id <>", value, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdGreaterThan(String value) {
            addCriterion("case_cash_plan_id >", value, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdGreaterThanOrEqualTo(String value) {
            addCriterion("case_cash_plan_id >=", value, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdLessThan(String value) {
            addCriterion("case_cash_plan_id <", value, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdLessThanOrEqualTo(String value) {
            addCriterion("case_cash_plan_id <=", value, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdLike(String value) {
            addCriterion("case_cash_plan_id like", value, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdNotLike(String value) {
            addCriterion("case_cash_plan_id not like", value, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdIn(List<String> values) {
            addCriterion("case_cash_plan_id in", values, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdNotIn(List<String> values) {
            addCriterion("case_cash_plan_id not in", values, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdBetween(String value1, String value2) {
            addCriterion("case_cash_plan_id between", value1, value2, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseCashPlanIdNotBetween(String value1, String value2) {
            addCriterion("case_cash_plan_id not between", value1, value2, "caseCashPlanId");
            return (Criteria) this;
        }

        public Criteria andCaseidIsNull() {
            addCriterion("caseid is null");
            return (Criteria) this;
        }

        public Criteria andCaseidIsNotNull() {
            addCriterion("caseid is not null");
            return (Criteria) this;
        }

        public Criteria andCaseidEqualTo(String value) {
            addCriterion("caseid =", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotEqualTo(String value) {
            addCriterion("caseid <>", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidGreaterThan(String value) {
            addCriterion("caseid >", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidGreaterThanOrEqualTo(String value) {
            addCriterion("caseid >=", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLessThan(String value) {
            addCriterion("caseid <", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLessThanOrEqualTo(String value) {
            addCriterion("caseid <=", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLike(String value) {
            addCriterion("caseid like", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotLike(String value) {
            addCriterion("caseid not like", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidIn(List<String> values) {
            addCriterion("caseid in", values, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotIn(List<String> values) {
            addCriterion("caseid not in", values, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidBetween(String value1, String value2) {
            addCriterion("caseid between", value1, value2, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotBetween(String value1, String value2) {
            addCriterion("caseid not between", value1, value2, "caseid");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseIsNull() {
            addCriterion("family_month_expense is null");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseIsNotNull() {
            addCriterion("family_month_expense is not null");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseEqualTo(BigDecimal value) {
            addCriterion("family_month_expense =", value, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseNotEqualTo(BigDecimal value) {
            addCriterion("family_month_expense <>", value, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseGreaterThan(BigDecimal value) {
            addCriterion("family_month_expense >", value, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("family_month_expense >=", value, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseLessThan(BigDecimal value) {
            addCriterion("family_month_expense <", value, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseLessThanOrEqualTo(BigDecimal value) {
            addCriterion("family_month_expense <=", value, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseIn(List<BigDecimal> values) {
            addCriterion("family_month_expense in", values, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseNotIn(List<BigDecimal> values) {
            addCriterion("family_month_expense not in", values, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("family_month_expense between", value1, value2, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andFamilyMonthExpenseNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("family_month_expense not between", value1, value2, "familyMonthExpense");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeIsNull() {
            addCriterion("retain_cash_type is null");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeIsNotNull() {
            addCriterion("retain_cash_type is not null");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeEqualTo(String value) {
            addCriterion("retain_cash_type =", value, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeNotEqualTo(String value) {
            addCriterion("retain_cash_type <>", value, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeGreaterThan(String value) {
            addCriterion("retain_cash_type >", value, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeGreaterThanOrEqualTo(String value) {
            addCriterion("retain_cash_type >=", value, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeLessThan(String value) {
            addCriterion("retain_cash_type <", value, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeLessThanOrEqualTo(String value) {
            addCriterion("retain_cash_type <=", value, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeLike(String value) {
            addCriterion("retain_cash_type like", value, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeNotLike(String value) {
            addCriterion("retain_cash_type not like", value, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeIn(List<String> values) {
            addCriterion("retain_cash_type in", values, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeNotIn(List<String> values) {
            addCriterion("retain_cash_type not in", values, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeBetween(String value1, String value2) {
            addCriterion("retain_cash_type between", value1, value2, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andRetainCashTypeNotBetween(String value1, String value2) {
            addCriterion("retain_cash_type not between", value1, value2, "retainCashType");
            return (Criteria) this;
        }

        public Criteria andDepositIsNull() {
            addCriterion("deposit is null");
            return (Criteria) this;
        }

        public Criteria andDepositIsNotNull() {
            addCriterion("deposit is not null");
            return (Criteria) this;
        }

        public Criteria andDepositEqualTo(BigDecimal value) {
            addCriterion("deposit =", value, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositNotEqualTo(BigDecimal value) {
            addCriterion("deposit <>", value, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositGreaterThan(BigDecimal value) {
            addCriterion("deposit >", value, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("deposit >=", value, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositLessThan(BigDecimal value) {
            addCriterion("deposit <", value, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositLessThanOrEqualTo(BigDecimal value) {
            addCriterion("deposit <=", value, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositIn(List<BigDecimal> values) {
            addCriterion("deposit in", values, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositNotIn(List<BigDecimal> values) {
            addCriterion("deposit not in", values, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("deposit between", value1, value2, "deposit");
            return (Criteria) this;
        }

        public Criteria andDepositNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("deposit not between", value1, value2, "deposit");
            return (Criteria) this;
        }

        public Criteria andFundIsNull() {
            addCriterion("fund is null");
            return (Criteria) this;
        }

        public Criteria andFundIsNotNull() {
            addCriterion("fund is not null");
            return (Criteria) this;
        }

        public Criteria andFundEqualTo(BigDecimal value) {
            addCriterion("fund =", value, "fund");
            return (Criteria) this;
        }

        public Criteria andFundNotEqualTo(BigDecimal value) {
            addCriterion("fund <>", value, "fund");
            return (Criteria) this;
        }

        public Criteria andFundGreaterThan(BigDecimal value) {
            addCriterion("fund >", value, "fund");
            return (Criteria) this;
        }

        public Criteria andFundGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fund >=", value, "fund");
            return (Criteria) this;
        }

        public Criteria andFundLessThan(BigDecimal value) {
            addCriterion("fund <", value, "fund");
            return (Criteria) this;
        }

        public Criteria andFundLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fund <=", value, "fund");
            return (Criteria) this;
        }

        public Criteria andFundIn(List<BigDecimal> values) {
            addCriterion("fund in", values, "fund");
            return (Criteria) this;
        }

        public Criteria andFundNotIn(List<BigDecimal> values) {
            addCriterion("fund not in", values, "fund");
            return (Criteria) this;
        }

        public Criteria andFundBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fund between", value1, value2, "fund");
            return (Criteria) this;
        }

        public Criteria andFundNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fund not between", value1, value2, "fund");
            return (Criteria) this;
        }

        public Criteria andCreditCardIsNull() {
            addCriterion("credit_card is null");
            return (Criteria) this;
        }

        public Criteria andCreditCardIsNotNull() {
            addCriterion("credit_card is not null");
            return (Criteria) this;
        }

        public Criteria andCreditCardEqualTo(BigDecimal value) {
            addCriterion("credit_card =", value, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardNotEqualTo(BigDecimal value) {
            addCriterion("credit_card <>", value, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardGreaterThan(BigDecimal value) {
            addCriterion("credit_card >", value, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("credit_card >=", value, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardLessThan(BigDecimal value) {
            addCriterion("credit_card <", value, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardLessThanOrEqualTo(BigDecimal value) {
            addCriterion("credit_card <=", value, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardIn(List<BigDecimal> values) {
            addCriterion("credit_card in", values, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardNotIn(List<BigDecimal> values) {
            addCriterion("credit_card not in", values, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("credit_card between", value1, value2, "creditCard");
            return (Criteria) this;
        }

        public Criteria andCreditCardNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("credit_card not between", value1, value2, "creditCard");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNull() {
            addCriterion("is_answer is null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNotNull() {
            addCriterion("is_answer is not null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerEqualTo(String value) {
            addCriterion("is_answer =", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotEqualTo(String value) {
            addCriterion("is_answer <>", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThan(String value) {
            addCriterion("is_answer >", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThanOrEqualTo(String value) {
            addCriterion("is_answer >=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThan(String value) {
            addCriterion("is_answer <", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThanOrEqualTo(String value) {
            addCriterion("is_answer <=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLike(String value) {
            addCriterion("is_answer like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotLike(String value) {
            addCriterion("is_answer not like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIn(List<String> values) {
            addCriterion("is_answer in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotIn(List<String> values) {
            addCriterion("is_answer not in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerBetween(String value1, String value2) {
            addCriterion("is_answer between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotBetween(String value1, String value2) {
            addCriterion("is_answer not between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIsNull() {
            addCriterion("analysis_teacher_score is null");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIsNotNull() {
            addCriterion("analysis_teacher_score is not null");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score =", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score <>", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreGreaterThan(BigDecimal value) {
            addCriterion("analysis_teacher_score >", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score >=", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreLessThan(BigDecimal value) {
            addCriterion("analysis_teacher_score <", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("analysis_teacher_score <=", value, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreIn(List<BigDecimal> values) {
            addCriterion("analysis_teacher_score in", values, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotIn(List<BigDecimal> values) {
            addCriterion("analysis_teacher_score not in", values, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("analysis_teacher_score between", value1, value2, "analysisTeacherScore");
            return (Criteria) this;
        }

        public Criteria andAnalysisTeacherScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("analysis_teacher_score not between", value1, value2, "analysisTeacherScore");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}