package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class FundProductExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundProductExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundCodeIsNull() {
            addCriterion("fund_code is null");
            return (Criteria) this;
        }

        public Criteria andFundCodeIsNotNull() {
            addCriterion("fund_code is not null");
            return (Criteria) this;
        }

        public Criteria andFundCodeEqualTo(String value) {
            addCriterion("fund_code =", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotEqualTo(String value) {
            addCriterion("fund_code <>", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeGreaterThan(String value) {
            addCriterion("fund_code >", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeGreaterThanOrEqualTo(String value) {
            addCriterion("fund_code >=", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeLessThan(String value) {
            addCriterion("fund_code <", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeLessThanOrEqualTo(String value) {
            addCriterion("fund_code <=", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeLike(String value) {
            addCriterion("fund_code like", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotLike(String value) {
            addCriterion("fund_code not like", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeIn(List<String> values) {
            addCriterion("fund_code in", values, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotIn(List<String> values) {
            addCriterion("fund_code not in", values, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeBetween(String value1, String value2) {
            addCriterion("fund_code between", value1, value2, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotBetween(String value1, String value2) {
            addCriterion("fund_code not between", value1, value2, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNull() {
            addCriterion("fund_name is null");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNotNull() {
            addCriterion("fund_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundNameEqualTo(String value) {
            addCriterion("fund_name =", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotEqualTo(String value) {
            addCriterion("fund_name <>", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThan(String value) {
            addCriterion("fund_name >", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_name >=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThan(String value) {
            addCriterion("fund_name <", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThanOrEqualTo(String value) {
            addCriterion("fund_name <=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLike(String value) {
            addCriterion("fund_name like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotLike(String value) {
            addCriterion("fund_name not like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameIn(List<String> values) {
            addCriterion("fund_name in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotIn(List<String> values) {
            addCriterion("fund_name not in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameBetween(String value1, String value2) {
            addCriterion("fund_name between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotBetween(String value1, String value2) {
            addCriterion("fund_name not between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundTypeIsNull() {
            addCriterion("fund_type is null");
            return (Criteria) this;
        }

        public Criteria andFundTypeIsNotNull() {
            addCriterion("fund_type is not null");
            return (Criteria) this;
        }

        public Criteria andFundTypeEqualTo(String value) {
            addCriterion("fund_type =", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeNotEqualTo(String value) {
            addCriterion("fund_type <>", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeGreaterThan(String value) {
            addCriterion("fund_type >", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeGreaterThanOrEqualTo(String value) {
            addCriterion("fund_type >=", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeLessThan(String value) {
            addCriterion("fund_type <", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeLessThanOrEqualTo(String value) {
            addCriterion("fund_type <=", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeLike(String value) {
            addCriterion("fund_type like", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeNotLike(String value) {
            addCriterion("fund_type not like", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeIn(List<String> values) {
            addCriterion("fund_type in", values, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeNotIn(List<String> values) {
            addCriterion("fund_type not in", values, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeBetween(String value1, String value2) {
            addCriterion("fund_type between", value1, value2, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeNotBetween(String value1, String value2) {
            addCriterion("fund_type not between", value1, value2, "fundType");
            return (Criteria) this;
        }

        public Criteria andNewNetValueIsNull() {
            addCriterion("new_net_value is null");
            return (Criteria) this;
        }

        public Criteria andNewNetValueIsNotNull() {
            addCriterion("new_net_value is not null");
            return (Criteria) this;
        }

        public Criteria andNewNetValueEqualTo(BigDecimal value) {
            addCriterion("new_net_value =", value, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueNotEqualTo(BigDecimal value) {
            addCriterion("new_net_value <>", value, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueGreaterThan(BigDecimal value) {
            addCriterion("new_net_value >", value, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("new_net_value >=", value, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueLessThan(BigDecimal value) {
            addCriterion("new_net_value <", value, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("new_net_value <=", value, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueIn(List<BigDecimal> values) {
            addCriterion("new_net_value in", values, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueNotIn(List<BigDecimal> values) {
            addCriterion("new_net_value not in", values, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("new_net_value between", value1, value2, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andNewNetValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("new_net_value not between", value1, value2, "newNetValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueIsNull() {
            addCriterion("total_new_value is null");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueIsNotNull() {
            addCriterion("total_new_value is not null");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueEqualTo(BigDecimal value) {
            addCriterion("total_new_value =", value, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueNotEqualTo(BigDecimal value) {
            addCriterion("total_new_value <>", value, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueGreaterThan(BigDecimal value) {
            addCriterion("total_new_value >", value, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_new_value >=", value, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueLessThan(BigDecimal value) {
            addCriterion("total_new_value <", value, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_new_value <=", value, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueIn(List<BigDecimal> values) {
            addCriterion("total_new_value in", values, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueNotIn(List<BigDecimal> values) {
            addCriterion("total_new_value not in", values, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_new_value between", value1, value2, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andTotalNewValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_new_value not between", value1, value2, "totalNewValue");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateIsNull() {
            addCriterion("nav_update_date is null");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateIsNotNull() {
            addCriterion("nav_update_date is not null");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateEqualTo(Date value) {
            addCriterionForJDBCDate("nav_update_date =", value, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("nav_update_date <>", value, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateGreaterThan(Date value) {
            addCriterionForJDBCDate("nav_update_date >", value, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("nav_update_date >=", value, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateLessThan(Date value) {
            addCriterionForJDBCDate("nav_update_date <", value, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("nav_update_date <=", value, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateIn(List<Date> values) {
            addCriterionForJDBCDate("nav_update_date in", values, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("nav_update_date not in", values, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("nav_update_date between", value1, value2, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andNavUpdateDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("nav_update_date not between", value1, value2, "navUpdateDate");
            return (Criteria) this;
        }

        public Criteria andHostingFeesIsNull() {
            addCriterion("hosting_fees is null");
            return (Criteria) this;
        }

        public Criteria andHostingFeesIsNotNull() {
            addCriterion("hosting_fees is not null");
            return (Criteria) this;
        }

        public Criteria andHostingFeesEqualTo(BigDecimal value) {
            addCriterion("hosting_fees =", value, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesNotEqualTo(BigDecimal value) {
            addCriterion("hosting_fees <>", value, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesGreaterThan(BigDecimal value) {
            addCriterion("hosting_fees >", value, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("hosting_fees >=", value, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesLessThan(BigDecimal value) {
            addCriterion("hosting_fees <", value, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesLessThanOrEqualTo(BigDecimal value) {
            addCriterion("hosting_fees <=", value, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesIn(List<BigDecimal> values) {
            addCriterion("hosting_fees in", values, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesNotIn(List<BigDecimal> values) {
            addCriterion("hosting_fees not in", values, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hosting_fees between", value1, value2, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andHostingFeesNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hosting_fees not between", value1, value2, "hostingFees");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesIsNull() {
            addCriterion("purchase_shares is null");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesIsNotNull() {
            addCriterion("purchase_shares is not null");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesEqualTo(BigDecimal value) {
            addCriterion("purchase_shares =", value, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesNotEqualTo(BigDecimal value) {
            addCriterion("purchase_shares <>", value, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesGreaterThan(BigDecimal value) {
            addCriterion("purchase_shares >", value, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("purchase_shares >=", value, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesLessThan(BigDecimal value) {
            addCriterion("purchase_shares <", value, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesLessThanOrEqualTo(BigDecimal value) {
            addCriterion("purchase_shares <=", value, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesIn(List<BigDecimal> values) {
            addCriterion("purchase_shares in", values, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesNotIn(List<BigDecimal> values) {
            addCriterion("purchase_shares not in", values, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("purchase_shares between", value1, value2, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andPurchaseSharesNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("purchase_shares not between", value1, value2, "purchaseShares");
            return (Criteria) this;
        }

        public Criteria andFundCompanyIsNull() {
            addCriterion("fund_company is null");
            return (Criteria) this;
        }

        public Criteria andFundCompanyIsNotNull() {
            addCriterion("fund_company is not null");
            return (Criteria) this;
        }

        public Criteria andFundCompanyEqualTo(String value) {
            addCriterion("fund_company =", value, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyNotEqualTo(String value) {
            addCriterion("fund_company <>", value, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyGreaterThan(String value) {
            addCriterion("fund_company >", value, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyGreaterThanOrEqualTo(String value) {
            addCriterion("fund_company >=", value, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyLessThan(String value) {
            addCriterion("fund_company <", value, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyLessThanOrEqualTo(String value) {
            addCriterion("fund_company <=", value, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyLike(String value) {
            addCriterion("fund_company like", value, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyNotLike(String value) {
            addCriterion("fund_company not like", value, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyIn(List<String> values) {
            addCriterion("fund_company in", values, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyNotIn(List<String> values) {
            addCriterion("fund_company not in", values, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyBetween(String value1, String value2) {
            addCriterion("fund_company between", value1, value2, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andFundCompanyNotBetween(String value1, String value2) {
            addCriterion("fund_company not between", value1, value2, "fundCompany");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateIsNull() {
            addCriterion("yearly_earnings_rate is null");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateIsNotNull() {
            addCriterion("yearly_earnings_rate is not null");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateEqualTo(BigDecimal value) {
            addCriterion("yearly_earnings_rate =", value, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateNotEqualTo(BigDecimal value) {
            addCriterion("yearly_earnings_rate <>", value, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateGreaterThan(BigDecimal value) {
            addCriterion("yearly_earnings_rate >", value, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("yearly_earnings_rate >=", value, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateLessThan(BigDecimal value) {
            addCriterion("yearly_earnings_rate <", value, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("yearly_earnings_rate <=", value, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateIn(List<BigDecimal> values) {
            addCriterion("yearly_earnings_rate in", values, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateNotIn(List<BigDecimal> values) {
            addCriterion("yearly_earnings_rate not in", values, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("yearly_earnings_rate between", value1, value2, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andYearlyEarningsRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("yearly_earnings_rate not between", value1, value2, "yearlyEarningsRate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIsNull() {
            addCriterion("update_date is null");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIsNotNull() {
            addCriterion("update_date is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateDateEqualTo(Date value) {
            addCriterion("update_date =", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotEqualTo(Date value) {
            addCriterion("update_date <>", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateGreaterThan(Date value) {
            addCriterion("update_date >", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateGreaterThanOrEqualTo(Date value) {
            addCriterion("update_date >=", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateLessThan(Date value) {
            addCriterion("update_date <", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateLessThanOrEqualTo(Date value) {
            addCriterion("update_date <=", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIn(List<Date> values) {
            addCriterion("update_date in", values, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotIn(List<Date> values) {
            addCriterion("update_date not in", values, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateBetween(Date value1, Date value2) {
            addCriterion("update_date between", value1, value2, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotBetween(Date value1, Date value2) {
            addCriterion("update_date not between", value1, value2, "updateDate");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}