package com.sztzjy.money_management.entity.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

@Data
@NoArgsConstructor
public class StuTheoryRecordDto {
    @ApiModelProperty("考试次数")
    private Integer examCount;

    @ApiModelProperty("最高分")
    private BigDecimal highestScore;

    @ApiModelProperty("最低分")
    private BigDecimal lowestScore;

    @ApiModelProperty("平均分")
    private BigDecimal averageScore;

    @ApiModelProperty("理论考核成绩权重")
    private BigDecimal weight;


}
