package com.sztzjy.money_management.entity.dto;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.Date;

@Data
@NoArgsConstructor
public class TrainingReportDto {
    @ApiModelProperty("实训报告ID")
    private String reportId;

    @ApiModelProperty("章节ID")
    private String chapterId;

    @ApiModelProperty("章节名称")
    private String chapterName;

    @ApiModelProperty("用户ID")
    private String userId;

    @ApiModelProperty("姓名")
    private String name;

    @ApiModelProperty("学号")
    private String studentId;

    @ApiModelProperty("班级")
    private String className;

    @ApiModelProperty("实训报告名称")
    private String reportName;

    @ApiModelProperty("实训报告上传时间")
    private Date uploadTime;

    @ApiModelProperty("实训报告大小/单位MB")
    private Integer reportSize;

    @ApiModelProperty("教师评分")
    private BigDecimal teacherScore;

    @ApiModelProperty("文件地址")
    private String filePath;

    @ApiModelProperty("学校ID")
    private String schoolId;

    @ApiModelProperty("教师评语")
    private String teacherComment;
}
