package com.sztzjy.money_management.mapper;

import com.sztzjy.money_management.entity.SynthesisPlanClient;
import com.sztzjy.money_management.entity.SynthesisPlanClientExample;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface SynthesisPlanClientMapper {
    long countByExample(SynthesisPlanClientExample example);

    int deleteByExample(SynthesisPlanClientExample example);

    int deleteByPrimaryKey(String stuClientId);

    int insert(SynthesisPlanClient record);

    int insertSelective(SynthesisPlanClient record);

    List<SynthesisPlanClient> selectByExample(SynthesisPlanClientExample example);

    SynthesisPlanClient selectByPrimaryKey(String stuClientId);

    int updateByExampleSelective(@Param("record") SynthesisPlanClient record, @Param("example") SynthesisPlanClientExample example);

    int updateByExample(@Param("record") SynthesisPlanClient record, @Param("example") SynthesisPlanClientExample example);

    int updateByPrimaryKeySelective(SynthesisPlanClient record);

    int updateByPrimaryKey(SynthesisPlanClient record);

    @Select("select count(*) from synthesis_plan_client where userid=#{userId}")
    Integer selectQianZaiTotalCount(@Param("userId") String userId);

    @Select("select count(*) from synthesis_plan_client where userid=#{userId} and submit_status='已审核'")
    Integer selectYiYouTotalCount(String userId);

    List<SynthesisPlanClient> getPotentialCustomerList(@Param("userId") String userId,
                                                       @Param("keyWord") String keyWord);

    @Select("select sum(use_time) from synthesis_plan_client where userid=#{userId}")
    Integer getTotalUseTime(String userId);

}