package com.sztzjy.money_management.service;

import com.nimbusds.jose.shaded.gson.Gson;
import com.sztzjy.money_management.entity.CaseInfo;
import com.sztzjy.money_management.entity.CaseInvestmentPlanInsuranceProductInfo;
import com.sztzjy.money_management.entity.StuCaseDto;
import com.sztzjy.money_management.entity.dto.CaseInvestmentPlanDto;
import com.sztzjy.money_management.util.ResultEntity;
import org.springframework.http.HttpStatus;

import java.math.BigDecimal;


/**
 * @Author xcj
 * @Date 2024/8/12
 */
public interface CaseService {
    ResultEntity<HttpStatus> insertCase(String caseInfo, String json, String operator, String type);

    ResultEntity<Object> getExamPoint(String caseID, String userId, String isAnswer, String type);

//    ResultEntity<HttpStatus> updateExamPoint(String json, String type);

    void commitTraining(String json, String type, String trainingId);

    ResultEntity addCorrelationTable(String type, String json, Gson gson, String operator);

    ResultEntity<HttpStatus> insertOrUpdateInvestmentPlan(CaseInvestmentPlanDto caseInvestmentPlanDto);

    ResultEntity<HttpStatus> insertComprehensivePlanCase(StuCaseDto stuCaseDto);
}
