package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class CaseInvestmentPlanFundProductInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CaseInvestmentPlanFundProductInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andFundProductinfoIdIsNull() {
            addCriterion("fund_productinfo_id is null");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdIsNotNull() {
            addCriterion("fund_productinfo_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdEqualTo(String value) {
            addCriterion("fund_productinfo_id =", value, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdNotEqualTo(String value) {
            addCriterion("fund_productinfo_id <>", value, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdGreaterThan(String value) {
            addCriterion("fund_productinfo_id >", value, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_productinfo_id >=", value, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdLessThan(String value) {
            addCriterion("fund_productinfo_id <", value, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdLessThanOrEqualTo(String value) {
            addCriterion("fund_productinfo_id <=", value, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdLike(String value) {
            addCriterion("fund_productinfo_id like", value, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdNotLike(String value) {
            addCriterion("fund_productinfo_id not like", value, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdIn(List<String> values) {
            addCriterion("fund_productinfo_id in", values, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdNotIn(List<String> values) {
            addCriterion("fund_productinfo_id not in", values, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdBetween(String value1, String value2) {
            addCriterion("fund_productinfo_id between", value1, value2, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andFundProductinfoIdNotBetween(String value1, String value2) {
            addCriterion("fund_productinfo_id not between", value1, value2, "fundProductinfoId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdIsNull() {
            addCriterion("product_select_id is null");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdIsNotNull() {
            addCriterion("product_select_id is not null");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdEqualTo(String value) {
            addCriterion("product_select_id =", value, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdNotEqualTo(String value) {
            addCriterion("product_select_id <>", value, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdGreaterThan(String value) {
            addCriterion("product_select_id >", value, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdGreaterThanOrEqualTo(String value) {
            addCriterion("product_select_id >=", value, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdLessThan(String value) {
            addCriterion("product_select_id <", value, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdLessThanOrEqualTo(String value) {
            addCriterion("product_select_id <=", value, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdLike(String value) {
            addCriterion("product_select_id like", value, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdNotLike(String value) {
            addCriterion("product_select_id not like", value, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdIn(List<String> values) {
            addCriterion("product_select_id in", values, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdNotIn(List<String> values) {
            addCriterion("product_select_id not in", values, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdBetween(String value1, String value2) {
            addCriterion("product_select_id between", value1, value2, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andProductSelectIdNotBetween(String value1, String value2) {
            addCriterion("product_select_id not between", value1, value2, "productSelectId");
            return (Criteria) this;
        }

        public Criteria andLevelIsNull() {
            addCriterion("level is null");
            return (Criteria) this;
        }

        public Criteria andLevelIsNotNull() {
            addCriterion("level is not null");
            return (Criteria) this;
        }

        public Criteria andLevelEqualTo(String value) {
            addCriterion("level =", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotEqualTo(String value) {
            addCriterion("level <>", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelGreaterThan(String value) {
            addCriterion("level >", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelGreaterThanOrEqualTo(String value) {
            addCriterion("level >=", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLessThan(String value) {
            addCriterion("level <", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLessThanOrEqualTo(String value) {
            addCriterion("level <=", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelLike(String value) {
            addCriterion("level like", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotLike(String value) {
            addCriterion("level not like", value, "level");
            return (Criteria) this;
        }

        public Criteria andLevelIn(List<String> values) {
            addCriterion("level in", values, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotIn(List<String> values) {
            addCriterion("level not in", values, "level");
            return (Criteria) this;
        }

        public Criteria andLevelBetween(String value1, String value2) {
            addCriterion("level between", value1, value2, "level");
            return (Criteria) this;
        }

        public Criteria andLevelNotBetween(String value1, String value2) {
            addCriterion("level not between", value1, value2, "level");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeIsNull() {
            addCriterion("investment_type is null");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeIsNotNull() {
            addCriterion("investment_type is not null");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeEqualTo(String value) {
            addCriterion("investment_type =", value, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeNotEqualTo(String value) {
            addCriterion("investment_type <>", value, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeGreaterThan(String value) {
            addCriterion("investment_type >", value, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeGreaterThanOrEqualTo(String value) {
            addCriterion("investment_type >=", value, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeLessThan(String value) {
            addCriterion("investment_type <", value, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeLessThanOrEqualTo(String value) {
            addCriterion("investment_type <=", value, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeLike(String value) {
            addCriterion("investment_type like", value, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeNotLike(String value) {
            addCriterion("investment_type not like", value, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeIn(List<String> values) {
            addCriterion("investment_type in", values, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeNotIn(List<String> values) {
            addCriterion("investment_type not in", values, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeBetween(String value1, String value2) {
            addCriterion("investment_type between", value1, value2, "investmentType");
            return (Criteria) this;
        }

        public Criteria andInvestmentTypeNotBetween(String value1, String value2) {
            addCriterion("investment_type not between", value1, value2, "investmentType");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyIsNull() {
            addCriterion("fund_investment_all_money is null");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyIsNotNull() {
            addCriterion("fund_investment_all_money is not null");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyEqualTo(BigDecimal value) {
            addCriterion("fund_investment_all_money =", value, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyNotEqualTo(BigDecimal value) {
            addCriterion("fund_investment_all_money <>", value, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyGreaterThan(BigDecimal value) {
            addCriterion("fund_investment_all_money >", value, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fund_investment_all_money >=", value, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyLessThan(BigDecimal value) {
            addCriterion("fund_investment_all_money <", value, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fund_investment_all_money <=", value, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyIn(List<BigDecimal> values) {
            addCriterion("fund_investment_all_money in", values, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyNotIn(List<BigDecimal> values) {
            addCriterion("fund_investment_all_money not in", values, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fund_investment_all_money between", value1, value2, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andFundInvestmentAllMoneyNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fund_investment_all_money not between", value1, value2, "fundInvestmentAllMoney");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalIsNull() {
            addCriterion("period_interval is null");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalIsNotNull() {
            addCriterion("period_interval is not null");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalEqualTo(String value) {
            addCriterion("period_interval =", value, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalNotEqualTo(String value) {
            addCriterion("period_interval <>", value, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalGreaterThan(String value) {
            addCriterion("period_interval >", value, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalGreaterThanOrEqualTo(String value) {
            addCriterion("period_interval >=", value, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalLessThan(String value) {
            addCriterion("period_interval <", value, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalLessThanOrEqualTo(String value) {
            addCriterion("period_interval <=", value, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalLike(String value) {
            addCriterion("period_interval like", value, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalNotLike(String value) {
            addCriterion("period_interval not like", value, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalIn(List<String> values) {
            addCriterion("period_interval in", values, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalNotIn(List<String> values) {
            addCriterion("period_interval not in", values, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalBetween(String value1, String value2) {
            addCriterion("period_interval between", value1, value2, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andPeriodIntervalNotBetween(String value1, String value2) {
            addCriterion("period_interval not between", value1, value2, "periodInterval");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateIsNull() {
            addCriterion("first_deduction_date is null");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateIsNotNull() {
            addCriterion("first_deduction_date is not null");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateEqualTo(Date value) {
            addCriterionForJDBCDate("first_deduction_date =", value, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("first_deduction_date <>", value, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateGreaterThan(Date value) {
            addCriterionForJDBCDate("first_deduction_date >", value, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("first_deduction_date >=", value, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateLessThan(Date value) {
            addCriterionForJDBCDate("first_deduction_date <", value, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("first_deduction_date <=", value, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateIn(List<Date> values) {
            addCriterionForJDBCDate("first_deduction_date in", values, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("first_deduction_date not in", values, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("first_deduction_date between", value1, value2, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andFirstDeductionDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("first_deduction_date not between", value1, value2, "firstDeductionDate");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountIsNull() {
            addCriterion("each_period_amount is null");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountIsNotNull() {
            addCriterion("each_period_amount is not null");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountEqualTo(BigDecimal value) {
            addCriterion("each_period_amount =", value, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountNotEqualTo(BigDecimal value) {
            addCriterion("each_period_amount <>", value, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountGreaterThan(BigDecimal value) {
            addCriterion("each_period_amount >", value, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("each_period_amount >=", value, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountLessThan(BigDecimal value) {
            addCriterion("each_period_amount <", value, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("each_period_amount <=", value, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountIn(List<BigDecimal> values) {
            addCriterion("each_period_amount in", values, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountNotIn(List<BigDecimal> values) {
            addCriterion("each_period_amount not in", values, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("each_period_amount between", value1, value2, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andEachPeriodAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("each_period_amount not between", value1, value2, "eachPeriodAmount");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsIsNull() {
            addCriterion("investment_years is null");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsIsNotNull() {
            addCriterion("investment_years is not null");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsEqualTo(BigDecimal value) {
            addCriterion("investment_years =", value, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsNotEqualTo(BigDecimal value) {
            addCriterion("investment_years <>", value, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsGreaterThan(BigDecimal value) {
            addCriterion("investment_years >", value, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("investment_years >=", value, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsLessThan(BigDecimal value) {
            addCriterion("investment_years <", value, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsLessThanOrEqualTo(BigDecimal value) {
            addCriterion("investment_years <=", value, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsIn(List<BigDecimal> values) {
            addCriterion("investment_years in", values, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsNotIn(List<BigDecimal> values) {
            addCriterion("investment_years not in", values, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("investment_years between", value1, value2, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andInvestmentYearsNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("investment_years not between", value1, value2, "investmentYears");
            return (Criteria) this;
        }

        public Criteria andAddTimeIsNull() {
            addCriterion("add_time is null");
            return (Criteria) this;
        }

        public Criteria andAddTimeIsNotNull() {
            addCriterion("add_time is not null");
            return (Criteria) this;
        }

        public Criteria andAddTimeEqualTo(Date value) {
            addCriterion("add_time =", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeNotEqualTo(Date value) {
            addCriterion("add_time <>", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeGreaterThan(Date value) {
            addCriterion("add_time >", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("add_time >=", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeLessThan(Date value) {
            addCriterion("add_time <", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeLessThanOrEqualTo(Date value) {
            addCriterion("add_time <=", value, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeIn(List<Date> values) {
            addCriterion("add_time in", values, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeNotIn(List<Date> values) {
            addCriterion("add_time not in", values, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeBetween(Date value1, Date value2) {
            addCriterion("add_time between", value1, value2, "addTime");
            return (Criteria) this;
        }

        public Criteria andAddTimeNotBetween(Date value1, Date value2) {
            addCriterion("add_time not between", value1, value2, "addTime");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}