package com.sztzjy.money_management.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class CaseRiskIndexExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CaseRiskIndexExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andCaseRiskIndexIdIsNull() {
            addCriterion("case_risk_index_id is null");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdIsNotNull() {
            addCriterion("case_risk_index_id is not null");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdEqualTo(String value) {
            addCriterion("case_risk_index_id =", value, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdNotEqualTo(String value) {
            addCriterion("case_risk_index_id <>", value, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdGreaterThan(String value) {
            addCriterion("case_risk_index_id >", value, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdGreaterThanOrEqualTo(String value) {
            addCriterion("case_risk_index_id >=", value, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdLessThan(String value) {
            addCriterion("case_risk_index_id <", value, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdLessThanOrEqualTo(String value) {
            addCriterion("case_risk_index_id <=", value, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdLike(String value) {
            addCriterion("case_risk_index_id like", value, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdNotLike(String value) {
            addCriterion("case_risk_index_id not like", value, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdIn(List<String> values) {
            addCriterion("case_risk_index_id in", values, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdNotIn(List<String> values) {
            addCriterion("case_risk_index_id not in", values, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdBetween(String value1, String value2) {
            addCriterion("case_risk_index_id between", value1, value2, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseRiskIndexIdNotBetween(String value1, String value2) {
            addCriterion("case_risk_index_id not between", value1, value2, "caseRiskIndexId");
            return (Criteria) this;
        }

        public Criteria andCaseidIsNull() {
            addCriterion("caseid is null");
            return (Criteria) this;
        }

        public Criteria andCaseidIsNotNull() {
            addCriterion("caseid is not null");
            return (Criteria) this;
        }

        public Criteria andCaseidEqualTo(String value) {
            addCriterion("caseid =", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotEqualTo(String value) {
            addCriterion("caseid <>", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidGreaterThan(String value) {
            addCriterion("caseid >", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidGreaterThanOrEqualTo(String value) {
            addCriterion("caseid >=", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLessThan(String value) {
            addCriterion("caseid <", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLessThanOrEqualTo(String value) {
            addCriterion("caseid <=", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidLike(String value) {
            addCriterion("caseid like", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotLike(String value) {
            addCriterion("caseid not like", value, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidIn(List<String> values) {
            addCriterion("caseid in", values, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotIn(List<String> values) {
            addCriterion("caseid not in", values, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidBetween(String value1, String value2) {
            addCriterion("caseid between", value1, value2, "caseid");
            return (Criteria) this;
        }

        public Criteria andCaseidNotBetween(String value1, String value2) {
            addCriterion("caseid not between", value1, value2, "caseid");
            return (Criteria) this;
        }

        public Criteria andAgeScoreIsNull() {
            addCriterion("age_score is null");
            return (Criteria) this;
        }

        public Criteria andAgeScoreIsNotNull() {
            addCriterion("age_score is not null");
            return (Criteria) this;
        }

        public Criteria andAgeScoreEqualTo(BigDecimal value) {
            addCriterion("age_score =", value, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreNotEqualTo(BigDecimal value) {
            addCriterion("age_score <>", value, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreGreaterThan(BigDecimal value) {
            addCriterion("age_score >", value, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("age_score >=", value, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreLessThan(BigDecimal value) {
            addCriterion("age_score <", value, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("age_score <=", value, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreIn(List<BigDecimal> values) {
            addCriterion("age_score in", values, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreNotIn(List<BigDecimal> values) {
            addCriterion("age_score not in", values, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("age_score between", value1, value2, "ageScore");
            return (Criteria) this;
        }

        public Criteria andAgeScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("age_score not between", value1, value2, "ageScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreIsNull() {
            addCriterion("job_score is null");
            return (Criteria) this;
        }

        public Criteria andJobScoreIsNotNull() {
            addCriterion("job_score is not null");
            return (Criteria) this;
        }

        public Criteria andJobScoreEqualTo(BigDecimal value) {
            addCriterion("job_score =", value, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreNotEqualTo(BigDecimal value) {
            addCriterion("job_score <>", value, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreGreaterThan(BigDecimal value) {
            addCriterion("job_score >", value, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("job_score >=", value, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreLessThan(BigDecimal value) {
            addCriterion("job_score <", value, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("job_score <=", value, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreIn(List<BigDecimal> values) {
            addCriterion("job_score in", values, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreNotIn(List<BigDecimal> values) {
            addCriterion("job_score not in", values, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("job_score between", value1, value2, "jobScore");
            return (Criteria) this;
        }

        public Criteria andJobScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("job_score not between", value1, value2, "jobScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreIsNull() {
            addCriterion("family_score is null");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreIsNotNull() {
            addCriterion("family_score is not null");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreEqualTo(BigDecimal value) {
            addCriterion("family_score =", value, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreNotEqualTo(BigDecimal value) {
            addCriterion("family_score <>", value, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreGreaterThan(BigDecimal value) {
            addCriterion("family_score >", value, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("family_score >=", value, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreLessThan(BigDecimal value) {
            addCriterion("family_score <", value, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("family_score <=", value, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreIn(List<BigDecimal> values) {
            addCriterion("family_score in", values, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreNotIn(List<BigDecimal> values) {
            addCriterion("family_score not in", values, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("family_score between", value1, value2, "familyScore");
            return (Criteria) this;
        }

        public Criteria andFamilyScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("family_score not between", value1, value2, "familyScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreIsNull() {
            addCriterion("house_score is null");
            return (Criteria) this;
        }

        public Criteria andHouseScoreIsNotNull() {
            addCriterion("house_score is not null");
            return (Criteria) this;
        }

        public Criteria andHouseScoreEqualTo(BigDecimal value) {
            addCriterion("house_score =", value, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreNotEqualTo(BigDecimal value) {
            addCriterion("house_score <>", value, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreGreaterThan(BigDecimal value) {
            addCriterion("house_score >", value, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("house_score >=", value, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreLessThan(BigDecimal value) {
            addCriterion("house_score <", value, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("house_score <=", value, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreIn(List<BigDecimal> values) {
            addCriterion("house_score in", values, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreNotIn(List<BigDecimal> values) {
            addCriterion("house_score not in", values, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_score between", value1, value2, "houseScore");
            return (Criteria) this;
        }

        public Criteria andHouseScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("house_score not between", value1, value2, "houseScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreIsNull() {
            addCriterion("exp_score is null");
            return (Criteria) this;
        }

        public Criteria andExpScoreIsNotNull() {
            addCriterion("exp_score is not null");
            return (Criteria) this;
        }

        public Criteria andExpScoreEqualTo(BigDecimal value) {
            addCriterion("exp_score =", value, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreNotEqualTo(BigDecimal value) {
            addCriterion("exp_score <>", value, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreGreaterThan(BigDecimal value) {
            addCriterion("exp_score >", value, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("exp_score >=", value, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreLessThan(BigDecimal value) {
            addCriterion("exp_score <", value, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("exp_score <=", value, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreIn(List<BigDecimal> values) {
            addCriterion("exp_score in", values, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreNotIn(List<BigDecimal> values) {
            addCriterion("exp_score not in", values, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("exp_score between", value1, value2, "expScore");
            return (Criteria) this;
        }

        public Criteria andExpScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("exp_score not between", value1, value2, "expScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreIsNull() {
            addCriterion("knowledge_score is null");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreIsNotNull() {
            addCriterion("knowledge_score is not null");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreEqualTo(BigDecimal value) {
            addCriterion("knowledge_score =", value, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreNotEqualTo(BigDecimal value) {
            addCriterion("knowledge_score <>", value, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreGreaterThan(BigDecimal value) {
            addCriterion("knowledge_score >", value, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("knowledge_score >=", value, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreLessThan(BigDecimal value) {
            addCriterion("knowledge_score <", value, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("knowledge_score <=", value, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreIn(List<BigDecimal> values) {
            addCriterion("knowledge_score in", values, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreNotIn(List<BigDecimal> values) {
            addCriterion("knowledge_score not in", values, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("knowledge_score between", value1, value2, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andKnowledgeScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("knowledge_score not between", value1, value2, "knowledgeScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreIsNull() {
            addCriterion("rci_score is null");
            return (Criteria) this;
        }

        public Criteria andRciScoreIsNotNull() {
            addCriterion("rci_score is not null");
            return (Criteria) this;
        }

        public Criteria andRciScoreEqualTo(BigDecimal value) {
            addCriterion("rci_score =", value, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreNotEqualTo(BigDecimal value) {
            addCriterion("rci_score <>", value, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreGreaterThan(BigDecimal value) {
            addCriterion("rci_score >", value, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("rci_score >=", value, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreLessThan(BigDecimal value) {
            addCriterion("rci_score <", value, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("rci_score <=", value, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreIn(List<BigDecimal> values) {
            addCriterion("rci_score in", values, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreNotIn(List<BigDecimal> values) {
            addCriterion("rci_score not in", values, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("rci_score between", value1, value2, "rciScore");
            return (Criteria) this;
        }

        public Criteria andRciScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("rci_score not between", value1, value2, "rciScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreIsNull() {
            addCriterion("tolerate_score is null");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreIsNotNull() {
            addCriterion("tolerate_score is not null");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreEqualTo(BigDecimal value) {
            addCriterion("tolerate_score =", value, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreNotEqualTo(BigDecimal value) {
            addCriterion("tolerate_score <>", value, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreGreaterThan(BigDecimal value) {
            addCriterion("tolerate_score >", value, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("tolerate_score >=", value, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreLessThan(BigDecimal value) {
            addCriterion("tolerate_score <", value, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("tolerate_score <=", value, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreIn(List<BigDecimal> values) {
            addCriterion("tolerate_score in", values, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreNotIn(List<BigDecimal> values) {
            addCriterion("tolerate_score not in", values, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tolerate_score between", value1, value2, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andTolerateScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("tolerate_score not between", value1, value2, "tolerateScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreIsNull() {
            addCriterion("consideration_score is null");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreIsNotNull() {
            addCriterion("consideration_score is not null");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreEqualTo(BigDecimal value) {
            addCriterion("consideration_score =", value, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreNotEqualTo(BigDecimal value) {
            addCriterion("consideration_score <>", value, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreGreaterThan(BigDecimal value) {
            addCriterion("consideration_score >", value, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("consideration_score >=", value, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreLessThan(BigDecimal value) {
            addCriterion("consideration_score <", value, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("consideration_score <=", value, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreIn(List<BigDecimal> values) {
            addCriterion("consideration_score in", values, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreNotIn(List<BigDecimal> values) {
            addCriterion("consideration_score not in", values, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("consideration_score between", value1, value2, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andConsiderationScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("consideration_score not between", value1, value2, "considerationScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreIsNull() {
            addCriterion("mentality_score is null");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreIsNotNull() {
            addCriterion("mentality_score is not null");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreEqualTo(BigDecimal value) {
            addCriterion("mentality_score =", value, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreNotEqualTo(BigDecimal value) {
            addCriterion("mentality_score <>", value, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreGreaterThan(BigDecimal value) {
            addCriterion("mentality_score >", value, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("mentality_score >=", value, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreLessThan(BigDecimal value) {
            addCriterion("mentality_score <", value, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("mentality_score <=", value, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreIn(List<BigDecimal> values) {
            addCriterion("mentality_score in", values, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreNotIn(List<BigDecimal> values) {
            addCriterion("mentality_score not in", values, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("mentality_score between", value1, value2, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andMentalityScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("mentality_score not between", value1, value2, "mentalityScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreIsNull() {
            addCriterion("character_score is null");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreIsNotNull() {
            addCriterion("character_score is not null");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreEqualTo(BigDecimal value) {
            addCriterion("character_score =", value, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreNotEqualTo(BigDecimal value) {
            addCriterion("character_score <>", value, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreGreaterThan(BigDecimal value) {
            addCriterion("character_score >", value, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("character_score >=", value, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreLessThan(BigDecimal value) {
            addCriterion("character_score <", value, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("character_score <=", value, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreIn(List<BigDecimal> values) {
            addCriterion("character_score in", values, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreNotIn(List<BigDecimal> values) {
            addCriterion("character_score not in", values, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("character_score between", value1, value2, "characterScore");
            return (Criteria) this;
        }

        public Criteria andCharacterScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("character_score not between", value1, value2, "characterScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreIsNull() {
            addCriterion("avoid_score is null");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreIsNotNull() {
            addCriterion("avoid_score is not null");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreEqualTo(BigDecimal value) {
            addCriterion("avoid_score =", value, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreNotEqualTo(BigDecimal value) {
            addCriterion("avoid_score <>", value, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreGreaterThan(BigDecimal value) {
            addCriterion("avoid_score >", value, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("avoid_score >=", value, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreLessThan(BigDecimal value) {
            addCriterion("avoid_score <", value, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("avoid_score <=", value, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreIn(List<BigDecimal> values) {
            addCriterion("avoid_score in", values, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreNotIn(List<BigDecimal> values) {
            addCriterion("avoid_score not in", values, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("avoid_score between", value1, value2, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAvoidScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("avoid_score not between", value1, value2, "avoidScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreIsNull() {
            addCriterion("adi_score is null");
            return (Criteria) this;
        }

        public Criteria andAdiScoreIsNotNull() {
            addCriterion("adi_score is not null");
            return (Criteria) this;
        }

        public Criteria andAdiScoreEqualTo(BigDecimal value) {
            addCriterion("adi_score =", value, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreNotEqualTo(BigDecimal value) {
            addCriterion("adi_score <>", value, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreGreaterThan(BigDecimal value) {
            addCriterion("adi_score >", value, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("adi_score >=", value, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreLessThan(BigDecimal value) {
            addCriterion("adi_score <", value, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("adi_score <=", value, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreIn(List<BigDecimal> values) {
            addCriterion("adi_score in", values, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreNotIn(List<BigDecimal> values) {
            addCriterion("adi_score not in", values, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("adi_score between", value1, value2, "adiScore");
            return (Criteria) this;
        }

        public Criteria andAdiScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("adi_score not between", value1, value2, "adiScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreIsNull() {
            addCriterion("loss_score is null");
            return (Criteria) this;
        }

        public Criteria andLossScoreIsNotNull() {
            addCriterion("loss_score is not null");
            return (Criteria) this;
        }

        public Criteria andLossScoreEqualTo(BigDecimal value) {
            addCriterion("loss_score =", value, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreNotEqualTo(BigDecimal value) {
            addCriterion("loss_score <>", value, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreGreaterThan(BigDecimal value) {
            addCriterion("loss_score >", value, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("loss_score >=", value, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreLessThan(BigDecimal value) {
            addCriterion("loss_score <", value, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreLessThanOrEqualTo(BigDecimal value) {
            addCriterion("loss_score <=", value, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreIn(List<BigDecimal> values) {
            addCriterion("loss_score in", values, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreNotIn(List<BigDecimal> values) {
            addCriterion("loss_score not in", values, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("loss_score between", value1, value2, "lossScore");
            return (Criteria) this;
        }

        public Criteria andLossScoreNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("loss_score not between", value1, value2, "lossScore");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIsNull() {
            addCriterion("update_date is null");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIsNotNull() {
            addCriterion("update_date is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateDateEqualTo(Date value) {
            addCriterion("update_date =", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotEqualTo(Date value) {
            addCriterion("update_date <>", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateGreaterThan(Date value) {
            addCriterion("update_date >", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateGreaterThanOrEqualTo(Date value) {
            addCriterion("update_date >=", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateLessThan(Date value) {
            addCriterion("update_date <", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateLessThanOrEqualTo(Date value) {
            addCriterion("update_date <=", value, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateIn(List<Date> values) {
            addCriterion("update_date in", values, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotIn(List<Date> values) {
            addCriterion("update_date not in", values, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateBetween(Date value1, Date value2) {
            addCriterion("update_date between", value1, value2, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUpdateDateNotBetween(Date value1, Date value2) {
            addCriterion("update_date not between", value1, value2, "updateDate");
            return (Criteria) this;
        }

        public Criteria andUseridIsNull() {
            addCriterion("userid is null");
            return (Criteria) this;
        }

        public Criteria andUseridIsNotNull() {
            addCriterion("userid is not null");
            return (Criteria) this;
        }

        public Criteria andUseridEqualTo(String value) {
            addCriterion("userid =", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridNotEqualTo(String value) {
            addCriterion("userid <>", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridGreaterThan(String value) {
            addCriterion("userid >", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridGreaterThanOrEqualTo(String value) {
            addCriterion("userid >=", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridLessThan(String value) {
            addCriterion("userid <", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridLessThanOrEqualTo(String value) {
            addCriterion("userid <=", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridLike(String value) {
            addCriterion("userid like", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridNotLike(String value) {
            addCriterion("userid not like", value, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridIn(List<String> values) {
            addCriterion("userid in", values, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridNotIn(List<String> values) {
            addCriterion("userid not in", values, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridBetween(String value1, String value2) {
            addCriterion("userid between", value1, value2, "userid");
            return (Criteria) this;
        }

        public Criteria andUseridNotBetween(String value1, String value2) {
            addCriterion("userid not between", value1, value2, "userid");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNull() {
            addCriterion("is_answer is null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIsNotNull() {
            addCriterion("is_answer is not null");
            return (Criteria) this;
        }

        public Criteria andIsAnswerEqualTo(String value) {
            addCriterion("is_answer =", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotEqualTo(String value) {
            addCriterion("is_answer <>", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThan(String value) {
            addCriterion("is_answer >", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerGreaterThanOrEqualTo(String value) {
            addCriterion("is_answer >=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThan(String value) {
            addCriterion("is_answer <", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLessThanOrEqualTo(String value) {
            addCriterion("is_answer <=", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerLike(String value) {
            addCriterion("is_answer like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotLike(String value) {
            addCriterion("is_answer not like", value, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerIn(List<String> values) {
            addCriterion("is_answer in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotIn(List<String> values) {
            addCriterion("is_answer not in", values, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerBetween(String value1, String value2) {
            addCriterion("is_answer between", value1, value2, "isAnswer");
            return (Criteria) this;
        }

        public Criteria andIsAnswerNotBetween(String value1, String value2) {
            addCriterion("is_answer not between", value1, value2, "isAnswer");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}