package com.sztzjy.money_management.mapper;

import com.sztzjy.money_management.entity.ScoreRank;
import com.sztzjy.money_management.entity.ScoreRankExample;

import java.math.BigDecimal;
import java.util.LinkedHashMap;
import java.util.List;

import com.sztzjy.money_management.entity.vo.TeaTrendVo;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
@Mapper
public interface ScoreRankMapper {
    long countByExample(ScoreRankExample example);

    int deleteByExample(ScoreRankExample example);

    int deleteByPrimaryKey(String rankId);

    int insert(ScoreRank record);

    int insertSelective(ScoreRank record);

    List<ScoreRank> selectByExample(ScoreRankExample example);

    ScoreRank selectByPrimaryKey(String rankId);

    int updateByExampleSelective(@Param("record") ScoreRank record, @Param("example") ScoreRankExample example);

    int updateByExample(@Param("record") ScoreRank record, @Param("example") ScoreRankExample example);

    int updateByPrimaryKeySelective(ScoreRank record);

    int updateByPrimaryKey(ScoreRank record);

    List<ScoreRank> selectFiveScoreByUserId(@Param("userId") String userId);

    List<TeaTrendVo> selectFiveAvgTotalScoreBySchoolIdAndClassName(ScoreRank record);

}